//+------------------------------------------------------------------+
//|                                           Volatility quality.mq4 |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 DeepSkyBlue
#property indicator_color2 PaleVioletRed
#property indicator_width1 2
#property indicator_width2 2

//
//
//
//
//

extern string TimeFrame = "Current time frame";
extern int    Length    = 5;
extern int    Method    = MODE_LWMA;
extern int    Smoothing = 1;
extern int    Filter    = 5;

//
//
//
//
//

double UpBuffer[];
double DnBuffer[];
double SumVQ[];
double trend[];

//
//
//
//
//

string indicatorFileName;
bool   calculateValue;
bool   returnBars;
int    timeFrame;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(4);
      SetIndexBuffer(0,UpBuffer); SetIndexStyle(0,DRAW_HISTOGRAM);
      SetIndexBuffer(1,DnBuffer); SetIndexStyle(1,DRAW_HISTOGRAM);
      SetIndexBuffer(2,SumVQ);
      SetIndexBuffer(3,trend);
      
      SetIndexEmptyValue(2,0.0);
         Filter    = MathMax(Filter,0);      
         Smoothing = MathMax(Smoothing,1);      

      //
      //
      //
      //
      //

      indicatorFileName = WindowExpertName();
      calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
      returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
      timeFrame         = stringToTimeFrame(TimeFrame);

      //
      //
      //
      //
      //
      
   IndicatorShortName(timeFrameToString(timeFrame)+" VQ bars ("+Length+")");
   return(0);
}
int deinit()
{
   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars <0)  return(-1);
   if(counted_bars >0)  counted_bars--;
      limit=MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { UpBuffer[0] = limit+1; return(0); }

   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame == Period())
   {
      for (i=limit; i>= 0; i--)
      {
         double MH  = iMA(NULL,0,Length,0,Method,PRICE_HIGH, i);
         double ML  = iMA(NULL,0,Length,0,Method,PRICE_LOW,  i);
         double MO  = iMA(NULL,0,Length,0,Method,PRICE_OPEN, i);
         double MC  = iMA(NULL,0,Length,0,Method,PRICE_CLOSE,i);
         double MC1 = iMA(NULL,0,Length,0,Method,PRICE_CLOSE,i+Smoothing);
      
         //
         //
         //
         //
         //
      
         if (MH != ML)
               double VQ = MathAbs(((MC - MC1) / MathMax(MH - ML,MathMax(MH - MC1,MC1 - ML)) + (MC - MO) / (MH - ML)) * 0.5) * ((MC - MC1 + (MC - MO)) * 0.5);
         else         VQ = 0.00;
         SumVQ[i] = SumVQ[i+1] + VQ;

         if (MathAbs(SumVQ[i]-SumVQ[i+1]) < Filter*Point) SumVQ[i]=SumVQ[i+1];

         //
         //
         //
         //
         //

         trend[i] = trend[i+1];
            if (SumVQ[i] > SumVQ[i+1]) trend[i] =  1;
            if (SumVQ[i] < SumVQ[i+1]) trend[i] = -1;
            if (trend[i]== 1) { DnBuffer[i] = Low[i];  UpBuffer[i] = High[i]; }
            if (trend[i]==-1) { DnBuffer[i] = High[i]; UpBuffer[i] = Low[i];  }
      }
      return(0);
   }
   
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for (i=limit;i>=0;i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         trend[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Length,Method,Smoothing,Filter,3,y);
            if (trend[i]== 1) { DnBuffer[i] = Low[i];  UpBuffer[i] = High[i]; }
            if (trend[i]==-1) { DnBuffer[i] = High[i]; UpBuffer[i] = Low[i];  }
   }
   return(0);         
}



//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}